#ifndef BROWSE_H
#define BROWSE_H

#include "text_t.h"
#include "gdbmclass.h"
#include "cgiargs.h"

class browseclass 
{
  
public:

  browseclass () {}
  virtual ~browseclass () {}

  virtual void get_browse_bar(const text_t &targetdoc, text_t &return_text) {}

  virtual void get_top_locator(cgiargsclass &args, gdbmclass &gdbm, int oversize, text_t &return_text) {}
  virtual void get_links(cgiargsclass &args, gdbmclass &gdbm, text_t &return_text) {}
  virtual void get_contents_arr(cgiargsclass &args, gdbmclass &gdbm, vector<text_t> &contents_arr) {}

protected:

  virtual void get_expanded_toc(cgiargsclass &args, text_t &booksection, 
				const text_t &classification, gdbmclass &gdbm, 
				text_t &return_text) {}
  virtual void get_standard_toc(cgiargsclass &args, text_t &booksection, 
				const text_t &classification, gdbmclass &gdbm, 
				text_t &return_text) {}
  virtual void get_alphabet_links (const text_t &booksection, gdbmclass &gdbm, 
				   const text_t &collection, text_t &return_text) {}
  virtual void get_title_arrows(text_t classification, gdbmclass &gdbm, 
				const text_t &collection, text_t &alphabet_arrows) {}
  virtual void get_contents (text_t expandlevel, gdbmclass &gdbm, 
			     const text_t &collection, vector<text_t> &contents, 
			     int &totalcols) {}

};


#endif
